            <<< VAXWRK::$1$DUS6:[NOTES$LIBRARY]ALPHANOTES.NOTE;3 >>>
                         -< Alpha Support conference >-
================================================================================
Note 1197.9                  architectural questions                      9 of 9
RDVAX::GRIES                                        189 lines   7-JAN-1993 12:59
--------------------------------------------------------------------------------
                              < Divide wizardry > - 1

The Appendix in the PRISM SRM was based on Ned Anderson's work in 1988,
has an error in it. It was pointed out at the time it was inculded in the
PRISM SRM.

To make the code work for the full range of unsigned integers discribed in 
the appendix more code is required. If one is interested in one half this range 
(the size of the signed positive numbers), then the algorithm will work.

The algorithm, which was not new, has the following error, if the remainder r
from dividing J by K is less than 1/2 K, the error added by "rounding up"
will cause I be one larger than Q whenever X * (K-r) >= J and X mod K = K-1.

Becuase of the way J is chosen this will only occur for X >= 2**(N-1), 
when N is the number of bits in the unsigned integer.

Incuded is a small program that will provide the approxomate recipocal
and set the required flags such that it will always produces the correct
unsigned integer divide result.

r gries
/* cxx code to test routine on 64 unsigned integer */

#include<stdlib.h>
#include<stdio.h>
#include "long.hpp"

#define size_uint64 64
int shift,flag,power_two;

static int t_small_ln_table[256] = {-1,0,1,1,2,2,2,2,3,3,3,3,3,3,3,3,
				     4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
				     5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
				     5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
				     6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
				     6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
				     6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
				     6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
				     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7};

int t_log2 (uint64 i)
{
int shift = size_uint64/4,ln2= size_uint64/2;
uint64 two= 1l,dec_cxx_temp;
    two <<= ln2;
    ln2-= 4;
    do
    {
	if ( two > i)
	{
	  two >>= shift;
	  ln2-= shift;
	}
	else
	{
	  two<<= shift;
	  ln2+= shift;
	}
	shift >>= 1;
    } while (shift>2);
    dec_cxx_temp= i >> ln2;
    return ln2 + t_small_ln_table[integer(dec_cxx_temp)];
}

#define t_quick_bits_length 24
#define t_max_quick_log2 ((1ul << t_quick_bits_length) - 1)

int log_2(uint64 i)
{
unsigned long x,ln2;

    if (i>=t_max_quick_log2) return t_log2(i);
    x= integer(i);
    if (x)
    {
      ln2= (t_quick_bits_length-8);
      while ((x >> ln2)==0) ln2-= 8;
      return ln2 + t_small_ln_table[x >> ln2];
    }
    return 0;
}

uint64 init_inv(uint64 e)
{
  uint64 d,r,t,dec_cxx_temp;
  int j;
  d= 1;
  d= d << (size_uint64-1);
  shift= -1;
  flag= 0;
  power_two= 0;
     while ((e.lo & 1)==0)
     {
       e= e >> 1;
       shift++;
     }
     t= d/e;
     r= d % e;
     while ((t.hi & 0x80000000ul)==0)
     {
       if (t<r)
         j= size_uint64-1-log_2(r);
       else
         j= size_uint64-1-log_2(t);
       r= (r << j);
       dec_cxx_temp= r/e;
       t= (t << j);
       t+= dec_cxx_temp;
       r= r % e;
       shift+= j;
     }
     dec_cxx_temp= r + r;
     if (dec_cxx_temp>e)
     {
       dec_cxx_temp= 1;
       flag= 1;
       t+= dec_cxx_temp;
     };
     if (r==0)
     {
       shift++;
       power_two= 1;
     }
     return t;

}

int main()
{
   uint64 x,y,z,check,t,dec_cxx_temp,limit,dec_cxx_one,
   max_uint64;

   int i;
   
   dec_cxx_one= uint64(1,0);
   max_uint64= -dec_cxx_one;
   for (x= 0x1;x!=0;x+= 2)
   {
   t= init_inv(x);
   y= max_uint64;
   limit= y - x;
   limit-= x;
   do
     {
       if (power_two)
       {
       /* code option 0 for powers of two */
	 z= y >> shift;
       }
       else
       if (flag)
       {
         /* code option 1 for rounded inv*/
         dec_cxx_temp= __UMULH(y,t);
         z= dec_cxx_temp >> shift;
       }
       else
       {
       /* code option 2 for rounded dividend*/
	 if (y == (max_uint64))
	   z= t >> shift;
	 else
         {
            dec_cxx_temp=y+1;
       	    dec_cxx_temp= __UMULH(dec_cxx_temp,t);
            z= dec_cxx_temp >> shift;
         }
       }
       check= y/x;
       if (check!=z)
       {
	 printf(" A= %lx%0lx s = %d\n",t.hi,t.lo,shift);
	 printf(" %lx%0lx / %lx = %lx%0lx != %lx%0lx\n",y.hi,y.lo,x.lo,z.hi,
                  z.lo,check.hi,check.lo);
       }
       y-= 1;
     } while ( y > limit);
     printf("x %d\n",x.lo);
   }
   return 0;
}
