$! copyright 2006 Hewlett-Packard Development Company, L.P.
$ create show_rscc.c

//  This example demonstrates reading the Alpha system cycle counter (SCC)
//  register.  The SCC is a value that is incremented very frequently.
//

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <hwrpbdef.h>
#include <evx_opcodes.h>
#include <c_asm.h>

#define QUOTE(s) #s
#define QUOTEVAL(s) QUOTE(s)
#define RSCC() (asm("call_pal " QUOTEVAL(EVX$PAL_RSCC)))

//  Reference the pointer to the Hardware Restart Parameter Block
//
extern HWRPB* exe$gpq_hwrpb;  

int main(void)
    {
     __int64 scc1, scc2, micro;

    scc1 = RSCC();
    sleep(2);
    scc2 = RSCC();

    //  The number of ticks per second is located in the HWRPB.
    //  Convert the difference into micro-seconds.

    micro = (1000000 * (scc2 - scc1)) /
        exe$gpq_hwrpb->hwrpb$iq_cycle_count_freq;

    printf("%Ld microseconds\n", micro);

    exit( EXIT_SUCCESS );
    }

$ cc/prefix=all show_rscc+sys$library:sys$lib_c/library
$ link/sysexe show_rscc
$ run show_rscc
