//  Copyright 2006 Hewlett-Packard Development Company, L.P.
//
//  An example of argc and argv, and of OpenVMS string descriptors
//  on OpenVMS.
//
//  Author: Stephen Hoffman, HP OpenVMS Engineering
//
#include <descrip.h>
#include <lib$routines.h>
#include <ssdef.h>
#include <stdio.h>
#include <string.h>
#include <stsdef.h>

#define TEXTBUFLEN 32
main( int argc, char **argv )
  {
  int RetStat;
  struct dsc$descriptor TextDsc = 
    { TEXTBUFLEN, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL };
  char TextBuf[TEXTBUFLEN];

  if ( argc != 2 )
    {
    printf("this is a foreign command; usage: argc text\n");
    return SS$_BADPARAM;
    }

  sscanf( argv[1], "%32s", TextBuf );

  TextDsc.dsc$w_length = strlen( TextBuf );
  TextDsc.dsc$a_pointer = TextBuf;

  RetStat = lib$put_output( &TextDsc );
  if (!$VMS_STATUS_SUCCESS( RetStat ))
    return RetStat;

  return RetStat;
  }

