//  Copyright 2006 Hewlett-Packard Development Company, L.P.
//
//  An example of various process control and process information
//  system services.
//
//  Author: Stephen Hoffman, HP OpenVMS Engineering
//

#include <descrip.h>
#include <jpidef.h>
#include <lib$routines.h>
#include <pscandef.h>
#include <ssdef.h>
#include <starlet.h>
#include <stdio.h>
#include <stsdef.h>
#include <unixlib.h>

#define MAXUSRLEN 32

struct ItemList3
    {
    short int ItemLength;
    short int ItemCode;
    void *ItemBuffer;
    void *ItemRetLen;
    };

main()
    {
    int RetStat;
    struct ItemList3 JpiItmLst[10], PscanItmLst[10];
    $DESCRIPTOR( UsernameDsc, "HOFFMAN" );
    $DESCRIPTOR( DateTimeText, "0 ::10");
    int DateTimeQuad[2];
    char Username[MAXUSRLEN];
    short int UsernameLen;
    char Processname[MAXUSRLEN];
    short int ProcessnameLen;
    int PID;
    int ef;
    int IOSB[2];
    int i;

    RetStat = lib$get_ef( &ef );
    if (!$VMS_STATUS_SUCCESS( RetStat ))
	lib$signal( RetStat );

    RetStat = sys$bintim( &DateTimeText, DateTimeQuad );
    if (!$VMS_STATUS_SUCCESS( RetStat ))
	lib$signal( RetStat );

    RetStat = sys$schdwk( 0, 0, DateTimeQuad, 0 );
    if (!$VMS_STATUS_SUCCESS( RetStat ))
	lib$signal( RetStat );


    PID = -1;
    i = 0;
    JpiItmLst[i].ItemLength	= MAXUSRLEN;
    JpiItmLst[i].ItemCode	= JPI$_USERNAME;
    JpiItmLst[i].ItemBuffer	= (void *) Username;
    JpiItmLst[i++].ItemRetLen	= &UsernameLen;
    JpiItmLst[i].ItemLength	= MAXUSRLEN;
    JpiItmLst[i].ItemCode	= JPI$_PRCNAM;
    JpiItmLst[i].ItemBuffer	= (void *) Processname;
    JpiItmLst[i++].ItemRetLen	= &ProcessnameLen;
    JpiItmLst[i].ItemLength	= 0;
    JpiItmLst[i].ItemCode	= 0;
    JpiItmLst[i].ItemBuffer	= NULL;
    JpiItmLst[i++].ItemRetLen	= NULL;
    i = 0;
    PscanItmLst[i].ItemLength	= 0;
    PscanItmLst[i].ItemCode	= PSCAN$_MODE;
    PscanItmLst[i].ItemBuffer	= (void *) JPI$K_INTERACTIVE;
    PscanItmLst[i++].ItemRetLen	= NULL;
    PscanItmLst[i].ItemLength	= 0;
    PscanItmLst[i].ItemCode	= 0;
    PscanItmLst[i].ItemBuffer	= NULL;
    PscanItmLst[i++].ItemRetLen	= NULL;

    RetStat = sys$schdwk(  0, 0, DateTimeQuad, 0 );
    if (!$VMS_STATUS_SUCCESS( RetStat ))
	lib$signal( RetStat );

    while ( TRUE )
	{
	RetStat = sys$process_scan( &PID, PscanItmLst );
	if (!$VMS_STATUS_SUCCESS( RetStat ))
	    lib$signal( RetStat );
	while ( TRUE )
	    {
	    RetStat = sys$getjpiw( ef, &PID, 0, JpiItmLst, IOSB, 0, 0 );
	    if ( RetStat == SS$_NOMOREPROC )
		{
		PID = -1;
		printf("*** commencing hibernation...\n");
		RetStat = sys$hiber();
		if (!$VMS_STATUS_SUCCESS( RetStat ))
		    lib$signal( RetStat );
		printf("*** awakened...\n");
		break;
		};
	    if (!$VMS_STATUS_SUCCESS( RetStat ))
		lib$signal( RetStat );
	    printf("username: %*.*s prcname: %*.*s\n",
		UsernameLen,UsernameLen,Username,
		ProcessnameLen,ProcessnameLen,Processname);
	    }
	}

    return SS$_NORMAL;
    }

