//  Copyright 2006 Hewlett-Packard Development Company, L.P.
//
//  An example of argc and argv, and of OpenVMS string descriptors
//  on OpenVMS.
//

#include <ssdef.h>
#include <starlet.h>
#include <stdio.h>
#include <string.h>
#include <stsdef.h>
#include <syidef.h>

#define HOSTNAMELEN 20
#define IL3MAXLEN   5

struct il3
    { 
    unsigned short int      buf_len;
    unsigned short int	    item_code;
    void		    *buf_addr;
    unsigned short int	    *ret_len;
    };
struct iostatus
    {
    short int      cond ;
    short int      count;
    int            dev_info;
    };

int get_nodename( char *, unsigned short int * );
main()
    {
    char    hostname[HOSTNAMELEN];
    unsigned short int     hostname_len;
    int     status;

    status = get_nodename( hostname, &hostname_len );

    if ( $VMS_STATUS_SUCCESS( status ) )
	{
        hostname[ hostname_len ] = '\0';
        printf( "%d %s\n", hostname_len, hostname );
        };

    return SS$_NORMAL;
    }

int get_nodename( char *nodename, unsigned short int *length )
    {
    int		i;
    int		status;
    struct il3	item_list[IL3MAXLEN];
    struct iostatus	iosb;

    i = 0;
    item_list[i].buf_len    = HOSTNAMELEN;
    item_list[i].item_code  = SYI$_NODENAME;
    item_list[i].buf_addr   = nodename;
    item_list[i++].ret_len  = length;
    item_list[i].buf_len    = 0;
    item_list[i].item_code  = 0;
    item_list[i].buf_addr   = 0;
    item_list[i++].ret_len  = 0;

    status = sys$getsyiw( 0, 0, 0, &item_list, &iosb, 0, 0 );

    if ( !($VMS_STATUS_SUCCESS( status )))
	return status;
    if ( !($VMS_STATUS_SUCCESS( iosb.cond )))
	return iosb.cond;

    return  status;
    }

