#module grantid "V1.0-000"
#pragma builtins

/*
** COPYRIGHT (c) 1992 BY
** DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.
** ALL RIGHTS RESERVED.
**
** THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED
** ONLY  IN  ACCORDANCE  OF  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE
** INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER
** COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
** OTHER PERSON.  NO TITLE TO AND  OWNERSHIP OF THE  SOFTWARE IS  HEREBY
** TRANSFERRED.
**
** THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE
** AND  SHOULD  NOT  BE  CONSTRUED  AS A COMMITMENT BY DIGITAL EQUIPMENT
** CORPORATION.
**
** DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS
** SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
*/

/*
**++
**  Facility:
**
**	Examples
**
**  Version: V1.0
**
**  Abstract:
**
**	Example of working with the $GRANTID and $REVOKEID calls
**
**  Author:
**	Steve Hoffman
**
**  Creation Date:  1-Jan-1990
**
**  Modification History:
**--
*/

/*
**  grantid.c
**
**  Example/test program that performs a $GRANTID or a $REVOKID on
**  the current process.  Called as a foreign command; requires
**  specification of a single argument, a 1 (grant) or a 0 (revoke).
**  Requires privileges. Not the most flexible of programs, and
**  definitely sports the archtypical user-hostile interface.
**
**  $ cc grantid
**  $ link grantid,sys$input/opt
**  sys$share:vaxcrtl/share
**  $ grandid :== $ddcu:[dir]grantid
*/

#include descrip

main( int argc, char **argv )
    {
    $DESCRIPTOR( id, "BATCH" );

    unsigned long int retstat;
    unsigned long int bool;
    unsigned long int mypid = 0;

    if ( argc != 2 )
        {
        printf(
"usage: foreign command \"grantid {1|0}\" to {enable|disable} BATCH\n");
        return 1;
        }

    sscanf( argv[1], "%d", &bool );

    if ( bool )
	retstat = sys$grantid( 0, 0, 0, &id, 0 );
    else
	retstat = sys$revokid( &mypid, 0, 0, &id, 0 );

    return( retstat );
    }


