/*
//   LIB$FID_TO_NAME.C
//   example of argv/argc, and of lib$fid_to_name
//   Copyright 2006 Hewlett-Packard Development Company, L.P.
//
//   Digital Equipment Corporation
//   Author: Steve XDELTA:: Hoffman
//
//
//   $ CC/DECC LIB$FID_TO_NAME
//   $ LINK LIB$FID_TO_NAME
//   $! if V6.2 or later:
//   $ DEFINE DCL$PATH SYS$DISK:[],SYS$SYSTEM:,SYS$ETC:
//   $! if prior to V6.2:
//   $ LIB$FID_TO_NAME :== $SYS$DISK:[]LIB$FID_TO_NAME
//   $ LIB$FID_TO_NAME device: x,y,z
//
*/
#include <descrip.h>
#include <libclidef.h>
#include <lib$routines.h>
#include <rms.h>
#include <ssdef.h>
#include <starlet.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stsdef.h>

print_usage()
    {
    printf("Convert FID to Name.\n");
    printf("DCL foreign command.\n");
    printf("Usage:\n");
    printf("  f2n device: fid1,fid2,fid3\n");
    abort();
    }
main( int argc, char **argv )
    {
    unsigned long int retstat;
    unsigned short int fid[3];
    $DESCRIPTOR( symbol, "F2N_FILENAME");
    struct dsc$descriptor ddcu;
    struct dsc$descriptor fname;
    char fnamebuf[NAM$C_MAXRSS];
    unsigned short int fnamelen;

    if ( argc != 3 )
	print_usage();

    /*
    //	Set up the input DDCU device and FID, and the output buffer.
    */
    ddcu.dsc$w_length = strlen( argv[1] );
    ddcu.dsc$b_dtype = DSC$K_DTYPE_T;
    ddcu.dsc$b_class = DSC$K_CLASS_S;
    ddcu.dsc$a_pointer = argv[1];

    sscanf( argv[2], "%d,%d,%d", &fid[0], &fid[1], &fid[2] );

    fname.dsc$w_length = NAM$C_MAXRSS;
    fname.dsc$b_dtype = DSC$K_DTYPE_T;
    fname.dsc$b_class = DSC$K_CLASS_S;
    fname.dsc$a_pointer = fnamebuf;

    /*
    //	Perform the FID translation
    */
    retstat = lib$fid_to_name( &ddcu, fid, &fname, &fnamelen, 0, 0 );
    if (!$VMS_STATUS_SUCCESS( retstat )) return retstat;

    fname.dsc$w_length = fnamelen; 

    /*
    //	Create a DCL symbol, and write out the filename...
    */
    retstat = lib$set_symbol( &symbol, &fname, &LIB$K_CLI_GLOBAL_SYM );
    if (!$VMS_STATUS_SUCCESS( retstat )) return retstat;
    retstat = lib$put_output( &fname );
    if (!$VMS_STATUS_SUCCESS( retstat )) return retstat;

    return SS$_NORMAL;
    }
