#pragma module LIB$FIND_IMAGE_SYMBOL "SRH X1.0-000"
#pragma builtins

/*
** COPYRIGHT (c) 1992 BY
** DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.
** ALL RIGHTS RESERVED.
**
** THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED
** ONLY  IN  ACCORDANCE  OF  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE
** INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER
** COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
** OTHER PERSON.  NO TITLE TO AND  OWNERSHIP OF THE  SOFTWARE IS  HEREBY
** TRANSFERRED.
**
** THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE
** AND  SHOULD  NOT  BE  CONSTRUED  AS A COMMITMENT BY DIGITAL EQUIPMENT
** CORPORATION.
**
** DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS
** SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
*/

/*
**++
**  Facility:
**
**      Examples
**
**  Version: V1.0
**
**  Abstract:
**
**      Example of working with the LIB$FIND_IMAGE_SYMBOL() call.
**	Looks up a symbol in the VAX C RTL (which is already in
**	VM somewhere since we're linked against it) and in the
**	MAILSHR RTL...
**
**  Author:
**      Steve Hoffman
**
**  Creation Date:  1-Jan-1990
**
**  Modification History:
**      Steve Hoffman  26-May-1998
**      updated for DEC C, and for OpenVMS Alpha
**--
*/
#include    <descrip.h>
#include    <lib$routines.h>
#include    <ssdef.h>
#include    <stsdef.h>
main()
    {
    int retstat;
    int *addr;
    /*
    **	The VAXCRTL filename, default name, and target symbol...
    */
    $DESCRIPTOR( deccshrfn,	"DECC$SHR" );
    $DESCRIPTOR( deccshrdn,	"SYS$SHARE:.EXE" );
    $DESCRIPTOR( deccshrsym,	"decc$fopen" );
    /*
    **	The MAILSHR filename, default name, and target symbol...
    */
    $DESCRIPTOR( mailshrfn,	"MAILSHR" );
    $DESCRIPTOR( mailshrdn,	"SYS$SHARE:.EXE" );
    $DESCRIPTOR( mailshrsym,	"MAIL$USER_GET_INFO" );

    /*
    **	And go look up the symbols...
    */
    retstat = lib$find_image_symbol(&deccshrfn,&deccshrsym,&addr,&deccshrdn);
    if (!$VMS_STATUS_SUCCESS( retstat )) return retstat;
    retstat = lib$find_image_symbol(&mailshrfn,&mailshrsym,&addr,&mailshrdn);
    if (!$VMS_STATUS_SUCCESS( retstat )) return retstat;

    return SS$_NORMAL;
    }
