/*
//  Copyright 2006 Hewlett-Packard Development Company, L.P.
//
//  An example of opendir and friends, on OpenVMS V7.0 and later.
//
//  Author: Stephen Hoffman, HP OpenVMS Engineering
*/

#ifdef VMS
#include <rms.h>
#define MAXDIRNAMLEN	NAM$C_MAXRSS
#define oserrno		vaxc$errno
#else
#define MAXDIRNAMLEN	256
#define oserrno		0
typedef struct
    {
    char d_name[MAXDIRNAMLEN+1];
    long d_ino;
    } dirent;
#endif

#include <errno.h>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

main(int argc, char **argv, char **envp )
    {
    DIR     *dfd;
    char    *dir;
    struct  dirent  *dp;

    dir = getenv("HOME");
    
    dfd = opendir(dir);
    if ( dfd == NULL)
	{
	printf("opendir(%s) failed, errno 0x0%x, oserrno 0x0%x\n",
	    dir,errno, oserrno);
	return errno;
	}
    printf("opendir(%s) succeeded\n",dir);
    dp = readdir(dfd);
    if ( dp == NULL)
	{
	printf("readdir(%s) failed, errno 0x0%x, oserrno 0x0%x\n",
	    dir,errno,oserrno);
	return errno;
	}
    while ( dp != NULL)
	{
	printf("%s\n",dp->d_name);
	dp = readdir(dfd);
	}

    closedir(dfd);
    return EXIT_SUCCESS;
    }
