Article 51381 of comp.os.vms:
Newsgroups: comp.os.vms
Path: jac.zko.dec.com!pa.dec.com!decuac.dec.com!haven.umd.edu!news.umbc.edu!europa.eng.gtefsd.com!howland.reston.ans.net!Germany.EU.net!gomel.knirsch.de!weller!ifwb!aw
From: aw@ifwb.wupper.de (Andreas Wylach)
Subject: Re: OpenVMS password generator
Organization: IfwB
Message-ID: <1995Jan9.093738.1807@ifwb.wupper.de>
References: <3eh39a$3s3@taquito.abq.bdm.com>
Date: Mon, 9 Jan 1995 09:37:38 GMT
Lines: 98

fnewman@bdmserver.bdm.com (Frank Newman I10752) writes:

>Is there a random password generator out there that I can call from a
>C program under OpenVMS?  Thanks.

>Frank Newman
>fnewman@alf.mcl.bdm.com

Try to use this code:


/*
 * Random Password Generator stolen from alt.sources and hacked up a 
 * little to make it a little bit more secure and the password easy 
 * to remember.
 * 
 * Totally random passwords are difficult to remember and are usually 
 * written down, which defeats the purpose.
 * 
 * The strategy is simple:
 * 
 * always start with a consonant alternating with vowels until the password
 * length is reached, enhancing the chances to find a password that one can
 * remember,
 * 
 * the random generator is seeded with time() multiplied by getpid() which
 * should make it difficult enough to find the exact combination,
 * 
 * the program loops several times (PASSWORDS) so as to give several 
 * passwords to choose from.
 * 
 *
 * Stolen from: Eric Kozowski <kozowski@ohsu.edu>
 *          by: Dr. Eberhard W. Lisse, <spel@hippo.RU.ac.ZA>,<el@lisse.NA>
 * 
 *
 */

#include <stdio.h>
#include <ctype.h>

#define PASSWORDS (10)                 /* How many passwords do we need ? */
#define MIN (6)                        /* Minimum length of the password  */
#define MAX (9)                         /* Maximum length of the password */

char consonant[] = "bcdfghjklmnpqrstvwz";     /* X left out intentionally */
char vowel[] = "aeiou";                       /* Y left out intentionally */

main()
{
   int  loop;                                       /* main loop variable */
   int  i;                      /* loop variable for the password length  */
   int  length;                           /* length of password at random */
   int  consonant_size;         /* needed for the random character search */
   int  vowel_size;             /* needed for the random character search */
   char passwd[MAX + 1];                                      /* Password */

   srand(time() * getpid());             /* Seed random number generator. */
   consonant_size = strlen(consonant);        /* needed for random lookup */
   vowel_size = strlen(vowel);                /* needed for random lookup */

   for (loop = 0; loop < PASSWORDS; loop++) {                /* main loop */
      length = rand() % (MAX - MIN) + MIN;      /* random password length */
      for (i = 0; i < length; i++) {                     /* do the lookup */
         if ((i % 2) == 0) {
            passwd[i] = consonant[rand() % consonant_size];        /* odd */
         } 
         else {
            passwd[i] = vowel[rand() % vowel_size];               /* even */
         }
      }
      passwd[length] = '\0';
      printf("%s\n", passwd);                                   /* done ! */
   }                                                         /* main loop */
}                                                               /* main() */

I included this code in a application of mine. Very nice piece of password
generator!

Hope this helps.



see ya,
Andreasw
--
Andreas W. Wylach | AW@IFWB.WUPPER.DE           | Information system from 
IfwB Wuppertal    | ANDREASW@AXPVMS.PA.DEC.COM  | students for students. 
W.- Germany       | WYLACH@WWCIP4.WIWI.UNI-WUPPERTAL.DE 
              -- Don't vax me like you used to *BREAK* --
              
            -- This is COMP.OS.VMS, not ALT.READ.MY.MIND. --
            				(Carl J Lydick)
-- 

see ya,
Andreasw
--


