#module	SET_LOGICAL "SRH X1.0-000"
#pragma builtins

/*
** COPYRIGHT (c) 1992 BY
** DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.
** ALL RIGHTS RESERVED.
**
** THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED
** ONLY  IN  ACCORDANCE  OF  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE
** INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER
** COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
** OTHER PERSON.  NO TITLE TO AND  OWNERSHIP OF THE  SOFTWARE IS  HEREBY
** TRANSFERRED.
**
** THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE
** AND  SHOULD  NOT  BE  CONSTRUED  AS A COMMITMENT BY DIGITAL EQUIPMENT
** CORPORATION.
**
** DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS
** SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
*/

/*
**++
**  Facility:
**
**	Examples
**
**  Version: X1.0
**
**  Abstract:
**
**	test program created for use with the lib$set_logical() call.
**
**  Author:
**	Steve Hoffman
**
**  Creation Date:  4-Feb-1992
**
**  Modification History:
**--
*/

#include <descrip.h>
#include <lnmdef.h>
#include <ssdef.h>
#include <stsdef.h>
struct item_list_3
    {
    unsigned short int itmlen;
    unsigned short int itmcod;
    void *itmbuf;
    unsigned short int *itmrla;
    };

set_logical()
MAIN_PROGRAM
    {
    unsigned long int retstat;
    int i;

    $DESCRIPTOR( lnm_d, "TEST_LOGICAL_NAME" );
    $DESCRIPTOR( eqvval_d, "TEST_LOGICAL_VALUE" );
    $DESCRIPTOR( lnmtbl_d, "LNM$JOB" );

#define MAX_TRANSLATIONS 5
    struct item_list_3 eqvlst_d[MAX_TRANSLATIONS];
    
    /*
    **	Create a logical using most defaults...
    */
    retstat = lib$set_logical( &lnm_d, &eqvval_d );
    if (!$VMS_STATUS_SUCCESS( retstat ))
	return retstat;

    /*
    **	Create a logical in the specified table...
    */
    retstat = lib$set_logical( &lnm_d, &eqvval_d, &lnmtbl_d );
    if (!$VMS_STATUS_SUCCESS( retstat ))
	return retstat;

    /*
    **	Create a logical with a bunch of translations.  The itemlist
    **	argument and structure (and contents) used by lib$set_logical()
    **	match those of the sys$crelnm system service itemlist argument.
    */
    i = 0;
    eqvlst_d[i].itmlen = lnm_d.dsc$w_length;
    eqvlst_d[i].itmbuf = lnm_d.dsc$a_pointer;
    eqvlst_d[i].itmcod = LNM$_STRING;
    eqvlst_d[i].itmrla = 0; i++;
    eqvlst_d[i].itmlen = eqvval_d.dsc$w_length;
    eqvlst_d[i].itmbuf = eqvval_d.dsc$a_pointer;
    eqvlst_d[i].itmcod = LNM$_STRING;
    eqvlst_d[i].itmrla = 0; i++;
    eqvlst_d[i].itmlen = lnmtbl_d.dsc$w_length;
    eqvlst_d[i].itmbuf = lnmtbl_d.dsc$a_pointer;
    eqvlst_d[i].itmcod = LNM$_STRING;
    eqvlst_d[i].itmrla = 0; i++;

    retstat = lib$set_logical( &lnm_d, 0, &lnmtbl_d, 0, eqvlst_d );
    if (!$VMS_STATUS_SUCCESS( retstat ))
	return retstat;

    return SS$_NORMAL;
    }
