#pragma module EXAMPLE "V1.2-000"

/*
** Copyright 2001 Compaq Computer Corporation
*/

/*
**++
**  Facility:
**
**	Examples
**
**  Version: V1.1
**
**  Abstract:
**
**	Example of working with C pointers and structures
**
**  Author:
**	Steve Hoffman
**
**  Creation Date:  1-Jan-1990
**
**  Modification History:
**       10-Aug-2001   Hoffman
**                     Updated for Compaq C, pass function as argument
**       01-Oct-2001   Hoffman
**                     Added an example of an array of function pointers,
**                     specifically the Hello and ByeBye routines...
**--
*/
/*
**  Demonstrate the copying of structures, and also pointers to functions.
**
**  $ CC/DECC X
**  $ LINK X
**  $ RUN X
*/
#include <stdio.h>
main( )
    {
    struct foobar
	{
	int x;
	} s1, s2;
    void zip( int ); 
    void zap( int );
    void zup( void (*)() );
    void Hello( void );
    void ByeBye( void );
    void (*zorch)( int );
    void (*Func[5])();

    s1.x = 12;
    s2.x = 5;
    zorch = zip;
    zorch( s1.x );
    zorch = zap;
    zorch( s2.x );

    s2 = s1;

    zorch = zip;
    zorch( s1.x );
    zorch = zap;
    zorch( s2.x );

    zup( zap );

    Func[0] = Hello;
    Func[1] = ByeBye;

    Func[0]();
    Func[1]();

    Func[0]();
    Func[0] = ByeBye;
    Func[0]();

    return 1;
    }
void zip( int z )
    {
    printf( "zip: %d\n", z );
    return;
    }

void zap( int z )
    {
    printf( "zap: %d\n", z );
    return;
    }
void zup( void (*zilch)() )
    {
    void (*zorch)( int );
    zorch = (void *) zilch;
    zorch( 303147 );
    return;
    }
void Hello( void )
    {
    printf("Hello!\n");
    return;
    }
void ByeBye( void )
    {
    printf("ByeBye!\n");
    return;
    }
