/*
** Copyright 2001 by Compaq Computer Corporation
*/

/*
**++
**  Facility:
**
**	Examples
**
**  Version: V1.0
**
**  Abstract:
**
**	Example of working with the LMF calls.
**      This example program checks for a hardwired product license.
**      If the license is not available, an error is signaled.
**
**  Author:
**	Steve Hoffman
**
**  Creation Date:  1-Jan-1990
**
**  Modification History:
**                  11-Jun-2001  Hoffman
**                  Now a sys$grant_license example
**--
*/

#include <descrip.h>
#include <lib$routines.h>
#include <lmfdef.h>
#include <ssdef.h>
#include <starlet.h>
#include <stddef.h>
#include <stdio.h>
#include <stsdef.h>
/* until these calls are in starlet.h */
int sys$lookup_license( void *, void *, void *);
int sys$grant_license( void *, void *, void *, void *);

lmf()
    {
    int retstat;
    $DESCRIPTOR( product, "C" );
    $DESCRIPTOR( producer, "DEC" );
    $DESCRIPTOR( prod_date, "1-JAN-1988" );
    int prod_version = 0x010000;
    int i;
    unsigned long int Context[2] = {0,0};
    char bintim[8];
    struct itmlst_3
	{
	short buflen;
	short itmcod;
	void *bufadr;
	void *bufrla;
	} itmlst[3];

    /*
    // Fill in the item list required by the call.  Includes the
    // required final, zero-filled, block.
    */
    i = 0;
    itmlst[i].buflen = 8;
    itmlst[i].itmcod = LMF$_PROD_DATE;
    itmlst[i].bufadr = (void *) bintim;
    itmlst[i++].bufrla = NULL;

    itmlst[i].buflen = 4;
    itmlst[i].itmcod = LMF$_PROD_VERSION;
    itmlst[i].bufadr = (void *) &prod_version;
    itmlst[i++].bufrla = NULL;

    itmlst[i].buflen = 0;
    itmlst[i].itmcod = 0;
    itmlst[i].bufadr = NULL;
    itmlst[i++].bufrla = NULL;

    /*
    // convert the time from ASCII to the internal quadword format.
    */
    retstat = sys$bintim( &prod_date, bintim );
    if ( !$VMS_STATUS_SUCCESS( retstat ))
	lib$signal( retstat );

    /*
    // The LMF signals on errors.
    */
    retstat = sys$grant_license( &product, &producer, Context, itmlst );
    if ( !$VMS_STATUS_SUCCESS( retstat ))
	lib$signal( retstat );

    printf("the sys$grant_license system service call worked.\n");

    return SS$_NORMAL;
    }

main()
    {
    int retstat;
    retstat = lmf();
    return retstat;
    }
