#pragma module TRNLNM "SRH X1.0-000"

/*
** COPYRIGHT (c) 1992, 1998 BY
** DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.
** ALL RIGHTS RESERVED.
**
** THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED
** ONLY  IN  ACCORDANCE  OF  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE
** INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER
** COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
** OTHER PERSON.  NO TITLE TO AND  OWNERSHIP OF THE  SOFTWARE IS  HEREBY
** TRANSFERRED.
**
** THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE
** AND  SHOULD  NOT  BE  CONSTRUED  AS A COMMITMENT BY DIGITAL EQUIPMENT
** CORPORATION.
**
** DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS
** SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
*/

/*
**++
**  Facility:
**
**	Examples
**
**  Version: V1.0
**
**  Abstract:
**
**	Example of working with the $TRNLNM service
**
**  Author:
**	Steve Hoffman
**
**  Creation Date:  1-Jan-1990
**
**  Modification History:
**--
*/
#include <ctype.h>
#include <descrip.h>
#include <lib$routines.h>
#include <lnmdef.h>
#include <psldef.h>
#include <ssdef.h>
#include <starlet.h>
#include <stdio.h>
#include <stdlib.h>
#include <str$routines.h>
#include <string.h>
#include <stsdef.h>
#define TIMBUFLEN 23
#define BUFLEN 255

#define LMF$C_PACKED_DATA_INDEX   0
#define LMF$C_PROD_TOKEN_INDEX   1
#define LMF$C_HW_ID_INDEX   2
#define LMF$C_USERNAME_BASE_INDEX   3
#define LMF$M_DEC_ISSUED   1
#define LMF$M_DEC_PRODUCED   2
#define LMF$M_MOD_UNITS   4
#define LMF$M_NO_SHARE   8
#define LMF$M_COMBINE   16
#define LMF$M_MODIFIED_NO_SHARE   32
#define LMF$M_OVERRIDE   64
#define LMF$M_RESERVE_UNITS   128
#define LMF$M_LIST_PRESENT   256
#define LMF$M_ALPHA   512
#define LMF$M_VAX_ALPHA   1024
#define LMF$M_PER_USER   2048
#define LMF$M_TOKEN_PRESENT   4096
#define LMF$M_HWID_PRESENT   8192
#define LMF$M_NO_COMBINE   16384
#define LMF$K_LENGTH   60
#define LMF$C_LENGTH   60
#define LMF$S_EXPIRATION_DATE   8
#define LMF$S_DATE   8
#define LMF$S_OPTIONS_OVERLAY   8

main( int argc, char **argv )
    {
    int RetStat;
    int LnmAttr;
    int LnmIdx;
    int LnmLength;
    int i;
    char LnmBuf0[BUFLEN];
    char LnmBuf1[BUFLEN];
    char LnmBuf2[BUFLEN];
    char TimBuf[TIMBUFLEN+1];
    unsigned char LnmChar;
    int LmfOpt;
    int LmfParId;
    int LmfGrantId;
    int LmfNextBaseIdx;
    int LmfOtherParId;
    int LmfOrigUnits;
    char *Foo = "Foo";

    struct
	{
	short size;
	short code;
	void *addr;
	void *rla;
	} ItemList[10];

    struct dsc$descriptor SrcLmf = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL };
    struct dsc$descriptor DstLmf = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL };
    struct dsc$descriptor TimDsc = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL };
    $DESCRIPTOR( SrcLmfLnmTbl, "LMF$LICENSE_TABLE" );

    if ( argc != 3 )
      {
      printf("usage %s src dst\n", argv[0] );
      return SS$_BADPARAM;
      }
    SrcLmf.dsc$w_length = strlen( argv[1] );
    SrcLmf.dsc$a_pointer = argv[1];
    DstLmf.dsc$w_length = strlen( argv[2] );
    DstLmf.dsc$a_pointer = argv[2];
    TimDsc.dsc$w_length = TIMBUFLEN;
    TimDsc.dsc$a_pointer = TimBuf;
    TimBuf[TIMBUFLEN] = 0;


    RetStat = str$upcase( &SrcLmf, &SrcLmf );
    if ( !$VMS_STATUS_SUCCESS( RetStat ))
      return RetStat;
    RetStat = str$upcase( &DstLmf, &DstLmf );
    if ( !$VMS_STATUS_SUCCESS( RetStat ))
      return RetStat;

    RetStat = lib$put_output( &SrcLmf );
    if ( !$VMS_STATUS_SUCCESS( RetStat ))
      return RetStat;
    RetStat = lib$put_output( &DstLmf );
    if ( !$VMS_STATUS_SUCCESS( RetStat ))
      return RetStat;
    RetStat = lib$put_output( &SrcLmfLnmTbl );
    if ( !$VMS_STATUS_SUCCESS( RetStat ))
      return RetStat;

    LnmAttr = 0;
    i = 0;
    LnmIdx = 0;
    ItemList[i].size  = sizeof( LnmIdx );
    ItemList[i].code  = LNM$_INDEX;
    ItemList[i].addr  = &LnmIdx; LnmIdx++;
    ItemList[i++].rla = NULL;
    ItemList[i].size  = strlen( Foo );
    ItemList[i].code  = LNM$_STRING;
    ItemList[i].addr  = Foo;
    ItemList[i++].rla = NULL;

    ItemList[i].size  = 0;
    ItemList[i].code  = 0;
    ItemList[i].addr  = NULL;
    ItemList[i++].rla = NULL;

    RetStat = sys$crelnm( &LnmAttr, &SrcLmfLnmTbl, &DstLmf,
      &PSL$C_USER, NULL );
/*       &PSL$C_KERNEL, NULL ); */
    if ( !$VMS_STATUS_SUCCESS( RetStat ))
      return RetStat;

  return SS$_NORMAL;

    i = 0;
    LnmIdx = 0;
    ItemList[i].size  = sizeof( LnmIdx );
    ItemList[i].code  = LNM$_INDEX;
    ItemList[i].addr  = &LnmIdx; LnmIdx++;
    ItemList[i++].rla = NULL;
    ItemList[i].size  = BUFLEN;
    ItemList[i].code  = LNM$_STRING;
    ItemList[i].addr  = LnmBuf0;
    ItemList[i++].rla = NULL;
    ItemList[i].size  = sizeof( int );
    ItemList[i].code  = LNM$_LENGTH;
    ItemList[i].addr  = &LnmLength;
    ItemList[i++].rla = NULL;

    ItemList[i].size  = sizeof( LnmIdx );
    ItemList[i].code  = LNM$_INDEX;
    ItemList[i].addr  = &LnmIdx; LnmIdx++;
    ItemList[i++].rla = NULL;
    ItemList[i].size  = BUFLEN;
    ItemList[i].code  = LNM$_STRING;
    ItemList[i].addr  = LnmBuf1;
    ItemList[i++].rla = NULL;

    ItemList[i].size  = sizeof( LnmIdx );
    ItemList[i].code  = LNM$_INDEX;
    ItemList[i].addr  = &LnmIdx; LnmIdx++;
    ItemList[i++].rla = NULL;
    ItemList[i].size  = BUFLEN;
    ItemList[i].code  = LNM$_STRING;
    ItemList[i].addr  = LnmBuf2;
    ItemList[i++].rla = NULL;

    ItemList[i].size  = 0;
    ItemList[i].code  = 0;
    ItemList[i].addr  = NULL;
    ItemList[i++].rla = NULL;
   
    RetStat = sys$trnlnm( 0, &SrcLmfLnmTbl, &SrcLmf, &PSL$C_SUPER, ItemList );
    if ( !$VMS_STATUS_SUCCESS( RetStat ))
      return RetStat;

    RetStat = sys$asctim( 0, &TimDsc, (void *) (LnmBuf0 + 0), 0 );
    printf("Termination Date: %s\n", TimBuf );

    RetStat = sys$asctim( 0, &TimDsc, (void *) (LnmBuf0 + 8), 0 );
    printf("Release Date: %s\n", TimBuf );

    printf("license version: %d\n", *(unsigned long int *) (LnmBuf0 + 16) );
    printf("units: %d\n", *(unsigned long int *) (LnmBuf0 + 20) );

    LmfOpt = *(unsigned long int *) (LnmBuf0 + 28);
    if ( LMF$M_DEC_ISSUED & LmfOpt )
      printf("LMF$M_DEC_ISSUED\n");
    if ( LMF$M_DEC_PRODUCED & LmfOpt )
      printf("LMF$M_DEC_PRODUCED\n");
    if ( LMF$M_MOD_UNITS & LmfOpt )
      printf("LMF$M_MOD_UNITS\n");
    if ( LMF$M_NO_SHARE & LmfOpt )
      printf("LMF$M_NO_SHARE\n");
    if ( LMF$M_COMBINE & LmfOpt )
      printf("LMF$M_COMBINE\n");
    if ( LMF$M_MODIFIED_NO_SHARE & LmfOpt )
      printf("LMF$M_MODIFIED_NO_SHARE\n");
    if ( LMF$M_OVERRIDE & LmfOpt )
      printf("LMF$M_OVERRIDE\n");
    if ( LMF$M_RESERVE_UNITS & LmfOpt )
      printf("LMF$M_RESERVE_UNITS\n");
    if ( LMF$M_LIST_PRESENT & LmfOpt )
      printf("LMF$M_LIST_PRESENT\n");
    if ( LMF$M_ALPHA & LmfOpt )
      printf("LMF$M_ALPHA\n");
    if ( LMF$M_VAX_ALPHA & LmfOpt )
      printf("LMF$M_VAX_ALPHA\n");
    if ( LMF$M_PER_USER & LmfOpt )
      printf("LMF$M_PER_USER\n");
    if ( LMF$M_TOKEN_PRESENT & LmfOpt )
      printf("LMF$M_TOKEN_PRESENT\n");
    if ( LMF$M_HWID_PRESENT & LmfOpt )
      printf("LMF$M_HWID_PRESENT\n");
    if ( LMF$M_NO_COMBINE & LmfOpt )
      printf("LMF$M_NO_COMBINE\n");

    LmfParId = *(unsigned long int *) (LnmBuf0 + 36);
    printf("LmfParId = 0x0%08.8x\n", LmfParId );
    LmfGrantId = *(unsigned long int *) (LnmBuf0 + 40);
    printf("LmfGrantId = 0x0%08.8x\n", LmfGrantId );
    LmfNextBaseIdx = *(unsigned long int *) (LnmBuf0 + 44);
    printf("LmfNextBaseIdx = 0x0%08.8x\n", LmfNextBaseIdx );
    LmfOtherParId = *(unsigned long int *) (LnmBuf0 + 48);
    printf("LmfOtherParId = 0x0%08.8x\n", LmfOtherParId );
    LmfOrigUnits = *(unsigned long int *) (LnmBuf0 + 56);
    printf("LmfOrigUnits = 0x0%08.8x\n", LmfOrigUnits );

/*
    for ( i = 0; i < LnmLength; i++ )
      {
      LnmChar = (unsigned char) LnmBuf0[i];
      if (( isprint( LnmBuf0[i] )) && ( !iscntrl( LnmBuf0[i] )))
        printf("%03.3d 0x0%02.2x - %c\n", i, LnmChar, LnmBuf0[i] );
      else
        printf("%03.3d 0x0%02.2x\n", i, LnmChar );
      }
*/
    printf("LnmBuf1: %s\n", LnmBuf1 );

    return SS$_NORMAL;
    }

/*

FIELD LMF$LMFXDEF_FIELDSET =
   SET

  LMF$Q_EXPIRATION_DATE = [0,0,0,0],    !  license expiration date
  LMF$Q_DATE = [8,0,0,0],               !  license date
  LMF$L_VERSION = [16,0,32,0],          !  license version
  LMF$L_UNITS = [20,0,32,0],            !  # of units authorized
  LMF$W_AVAIL_IDX = [24,0,16,0],        !  availability selector
  LMF$W_NUSER_IDX = [26,0,16,0],        !  useability selector
    LMF$Q_OPTIONS = [28,0,0,0],         !  options bitmask
      LMF$V_Dec_issued = [28,0,1,0],    !  Dec issued license
      LMF$V_Dec_produced = [28,1,1,0],  !  Dec produced product
      LMF$V_MOD_UNITS = [28,2,1,0],     !  modifible units
      LMF$V_NO_SHARE = [28,3,1,0],      !  not sharable
      LMF$V_COMBINE = [28,4,1,0],       !  force PAK combination
      LMF$V_Modified_no_share = [28,5,1,0], !  no_share bit modified by user
      LMF$V_OVERRIDE = [28,6,1,0],      !  do not count units
      LMF$v_reserve_units = [28,7,1,0], !  subscriber licensing
      LMF$v_list_present = [28,8,1,0],  !  name list
      LMF$v_alpha = [28,9,1,0],         !  pak is for alpha only
      LMF$v_vax_alpha = [28,10,1,0],    !  pak is for alpha or vax
      LMF$v_per_user = [28,11,1,0],     !  pak is a per_user license
      LMF$v_token_present = [28,12,1,0], !  product token present
      LMF$v_hwid_present = [28,13,1,0], !  hardware ID present
      LMF$v_no_combine = [28,14,1,0],   !  extra locks used
    LMF$R_OPTIONS_BITS = [28,0,16,0],
  LMF$R_OPTIONS_OVERLAY = [28,0,0,0],
  LMF$L_PARID = [36,0,32,0],            !  Parent (producer) lock id
  LMF$l_grantid = [40,0,32,0],
  LMF$l_nxtbaseidx = [44,0,32,0],       !  logical index for next
!  license type
  LMF$l_other_parid = [48,0,32,0],      !  for no_combine, another lkid
!  lock id is stored here
  LMF$l_per_user_parid = [52,0,32,0],   !  Parent for per_user
  LMF$l_orig_units = [56,0,32,0]        !  # of units before division
  TES;

*/

